Bug 1216055 - Review Request: ardour4 - Digital Audio Workstation
Summary: Review Request: ardour4 - Digital Audio Workstation
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Brendan Jones
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1215223 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-04-28 12:23 UTC by Nils Philippsen
Modified: 2015-05-12 20:45 UTC (History)
6 users (show)

Fixed In Version: ardour4-4.0.0-2.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-05-11 00:12:16 UTC
Type: ---
brendan.jones.it: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Nils Philippsen 2015-04-28 12:23:24 UTC
Spec URL: https://nphilipp.fedorapeople.org/review/ardour4/ardour4.spec
SRPM URL: https://nphilipp.fedorapeople.org/review/ardour4/ardour4-4.0.0-0.2.fc23.src.rpm
Description: Ardour is a multi-channel digital audio workstation, allowing users to record, edit, mix and master audio and MIDI projects. It is targeted at audio
engineers, musicians, soundtrack editors and composers.
Fedora Account System Username: nphilipp

NB: This is major version 4 of ardour, and installable in parallel to the legacy versions 2 and 3 (ardour and ardour3 respectively). We keep the old versions around to ensure maximum compatibility when handling sessions created by these old versions, but users should use the latest version for new sessions.

Comment 1 Nils Philippsen 2015-04-28 12:25:13 UTC
*** Bug 1215223 has been marked as a duplicate of this bug. ***

Comment 2 Nils Philippsen 2015-04-28 12:31:29 UTC
NB^2: I have built packages in COPR so the functionality can be easily tested, these will be updated if changes are necessary. To ease transitioning, the packages will have release numbers of "0.x", I'll flip that to "1" when the review is through for the build in koji.

Comment 3 Jonathan Underwood 2015-04-28 16:10:34 UTC
I am a bit snowed under this week, but if noone has picked this review up by next week I will.

Comment 4 Fernando Lopez-Lezcano 2015-04-28 16:22:10 UTC
(In reply to Nils Philippsen from comment #2)
> NB^2: I have built packages in COPR so the functionality can be easily
> tested, these will be updated if changes are necessary. To ease
> transitioning, the packages will have release numbers of "0.x", I'll flip
> that to "1" when the review is through for the build in koji.

Funny, I did exactly that over the weekend to test (in my own build server)... :-)

Thanks for taking this up!

I had to remove the "--lv2-system" config option from the waf call, add "canvas" to the internal library list and change ardour3 to ardour4 in the desktop and mime xml files. That gave me a (very untested but functional) package.

Comment 5 Nils Philippsen 2015-04-29 09:04:45 UTC
(In reply to Fernando Lopez-Lezcano from comment #4) 
> I had to remove the "--lv2-system" config option from the waf call, add
> "canvas" to the internal library list and change ardour3 to ardour4 in the
> desktop and mime xml files. That gave me a (very untested but functional)
> package.

Yeah, the differences in building are minuscule compared to ardour3. I basically did what you did, plus this:

- adjust minimum required jack version to 1.9.10, this prevents the package from being built on F-20 ATM
- build with the additional new alsa and dummy backends, add BR: dbus-devel
- do some shenanigans to treat normal and locale data files (which reside in /usr/share/ardour4/locale now) differently -- we want pull in the latter with %find_lang so simply listing %{_datadir}/ardour4 won't fly

Comment 6 Brendan Jones 2015-04-30 01:53:00 UTC
This is largely not that diffreetn from ardour3. This is APPROVED

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- Static libraries in -static or -devel subpackage, providing -devel if
  present.
  Note: Package has .a files: ardour4. Illegal package name: ardour4. Does not
  provide -static: ardour4.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "WTFPL WTFPL (v2)", "LGPL (v2.1 or later) (with incorrect FSF address)",
     "LGPL (v2 or later) (with incorrect FSF address)", "LGPL (v2.1) (with
     incorrect FSF address)", "ISC", "*No copyright* GPL (v2 or later)", "*No
     copyright* LGPL (v2.1 or later)", "*No copyright* GPL (v2 or later) (with
     incorrect FSF address)", "GPL (v3 or later)", "zlib/libpng", "LGPL (v3 or
     later)", "GPL (v2 or later) (with incorrect FSF address)", "BSD (2
     clause)", "*No copyright* LGPL (v2 or later) (with incorrect FSF
     address)", "GPL", "*No copyright* WTFPL", "GPL (v2 or later)", "MIT/X11
     (BSD like)", "BSD (3 clause)", "Unknown or generated", "BSD (4 clause)",
     "BSL (v1.0)", "GPL (v2)". 375 files have unknown license. Detailed output
     of licensecheck in /tmp/ardour4/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
     Note: Using prebuilt rpms.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: update-desktop-database is invoked in %post and %postun if package
     contains desktop file(s) with a MimeType: entry.
     Note: desktop file(s) with MimeType entry in ardour4
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in ardour4
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
     Note: Test run failed
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Test run failed
[x]: Packages must not store files under /srv, /opt or /usr/local
     Note: Test run failed
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or desktop-
     file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

===== SHOULD items =====

Generic:
[!]: Reviewer should test that the package builds in mock.
[!]: update-mime-database is invoked in %post and %postun if package stores
     mime configuration in /usr/share/mime/packages.
     Note: mimeinfo files in: ardour4
     See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#mimeinfo
[x]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Test run failed
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: ardour4-4.0.0-0.2.fc23.i686.rpm
          ardour4-4.0.0-0.2.fc23.src.rpm
ardour4.i686: W: spelling-error %description -l en_US Ardour -> Armour, Ar dour, Ar-dour
ardour4.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libgtkmm2ext.so
ardour4.i686: W: cross-directory-hard-link /usr/share/ardour4/icons/ardour_icon_512px.png /usr/share/icons/hicolor/512x512/apps/ardour4.png
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libardouralsautil.so
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libcanvas.so
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libqmdsp.so
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libardour.so
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libevoral.so
ardour4.i686: W: cross-directory-hard-link /usr/share/ardour4/icons/ardour_icon_16px.png /usr/share/icons/hicolor/16x16/apps/ardour4.png
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/vamp/libardourvampplugins.so
ardour4.i686: W: cross-directory-hard-link /usr/share/icons/hicolor/32x32/apps/ardour4.png /usr/share/ardour4/icons/ardour_icon_32px.png
ardour4.i686: W: dangling-relative-symlink /usr/share/ardour4/ArdourMono.ttf ../fonts/google-droid/DroidSansMono.ttf
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libpbd.so
ardour4.i686: W: cross-directory-hard-link /usr/share/icons/hicolor/22x22/apps/ardour4.png /usr/share/ardour4/icons/ardour_icon_22px.png
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libaudiographer.so
ardour4.i686: W: cross-directory-hard-link /usr/share/icons/hicolor/256x256/apps/ardour4.png /usr/share/ardour4/icons/ardour_icon_256px.png
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libsmf.a
ardour4.i686: W: cross-directory-hard-link /usr/share/ardour4/icons/ardour_icon_48px.png /usr/share/icons/hicolor/48x48/apps/ardour4.png
ardour4.i686: W: devel-file-in-non-devel-package /usr/lib/ardour4/libmidipp.so
ardour4.src: W: spelling-error %description -l en_US Ardour -> Armour, Ar dour, Ar-dour
ardour4.src: W: spelling-error %description -l en_US multi -> mulch, mufti
ardour4.src: W: strange-permission Ardour-4.0.0.tar.bz2 0640L
ardour4.src: W: invalid-url Source0: Ardour-4.0.0.tar.bz2
2 packages and 0 specfiles checked; 0 errors, 24 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
ardour4 (rpmlib, GLIBC filtered):
    /bin/sh
    config(ardour4)
    google-droid-sans-mono-fonts
    libFLAC.so.8
    libX11.so.6
    libasound.so.2
    libasound.so.2(ALSA_0.9)
    libasound.so.2(ALSA_0.9.0rc4)
    libatk-1.0.so.0
    libatkmm-1.6.so.1
    libaubio.so.2
    libbluetooth.so.3
    libc.so.6
    libcairo.so.2
    libcairomm-1.0.so.1
    libcurl.so.4
    libcwiid.so.1
    libdbus-1.so.3
    libdbus-1.so.3(LIBDBUS_1_3)
    libdl.so.2
    libfftw3f.so.3
    libfontconfig.so.1
    libfreetype.so.6
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libgdk-x11-2.0.so.0
    libgdk_pixbuf-2.0.so.0
    libgdkmm-2.4.so.1
    libgio-2.0.so.0
    libgiomm-2.4.so.1
    libglib-2.0.so.0
    libglibmm-2.4.so.1
    libgobject-2.0.so.0
    libgthread-2.0.so.0
    libgtk-x11-2.0.so.0
    libgtkmm-2.4.so.1
    libjack.so.0
    liblilv-0.so.0
    liblo.so.7
    liblrdf.so.2
    libltc.so.11
    libm.so.6
    libogg.so.0
    libpango-1.0.so.0
    libpangocairo-1.0.so.0
    libpangoft2-1.0.so.0
    libpangomm-1.4.so.1
    libpthread.so.0
    librubberband.so.2
    libsamplerate.so.0
    libsamplerate.so.0(libsamplerate.so.0.0)
    libserd-0.so.0
    libsigc-2.0.so.0
    libsndfile.so.1
    libsndfile.so.1(libsndfile.so.1.0)
    libsord-0.so.0
    libsratom-0.so.0
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    libstdc++.so.6(CXXABI_1.3.1)
    libsuil-0.so.0
    libtag.so.1
    libvamp-hostsdk.so.3
    libvamp-sdk.so.2
    libxml2.so.2
    libxml2.so.2(LIBXML2_2.4.30)
    libxml2.so.2(LIBXML2_2.6.0)
    rtld(GNU_HASH)



Provides
--------
ardour4:
    application()
    application(ardour4.desktop)
    ardour4
    ardour4(x86-32)
    config(ardour4)
    mimehandler(application/x-ardour3)



Unversioned so-files
--------------------
ardour4: /usr/lib/ardour4/backends/libalsa_audiobackend.so
ardour4: /usr/lib/ardour4/backends/libdummy_audiobackend.so
ardour4: /usr/lib/ardour4/backends/libjack_audiobackend.so
ardour4: /usr/lib/ardour4/engines/libclearlooks.so
ardour4: /usr/lib/ardour4/libardour.so
ardour4: /usr/lib/ardour4/libardouralsautil.so
ardour4: /usr/lib/ardour4/libardourcp.so
ardour4: /usr/lib/ardour4/libaudiographer.so
ardour4: /usr/lib/ardour4/libcanvas.so
ardour4: /usr/lib/ardour4/libevoral.so
ardour4: /usr/lib/ardour4/libgtkmm2ext.so
ardour4: /usr/lib/ardour4/libmidipp.so
ardour4: /usr/lib/ardour4/libpbd.so
ardour4: /usr/lib/ardour4/libqmdsp.so
ardour4: /usr/lib/ardour4/libtimecode.so
ardour4: /usr/lib/ardour4/lv2/reasonablesynth.lv2/reasonablesynth.so
ardour4: /usr/lib/ardour4/panners/libpan1in2out.so
ardour4: /usr/lib/ardour4/panners/libpan2in2out.so
ardour4: /usr/lib/ardour4/panners/libpanbalance.so
ardour4: /usr/lib/ardour4/panners/libpanvbap.so
ardour4: /usr/lib/ardour4/surfaces/libardour_generic_midi.so
ardour4: /usr/lib/ardour4/surfaces/libardour_mcp.so
ardour4: /usr/lib/ardour4/surfaces/libardour_osc.so
ardour4: /usr/lib/ardour4/surfaces/libardour_wiimote.so
ardour4: /usr/lib/ardour4/vamp/libardourvampplugins.so

Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review --prebuilt --rpm-spec --name ardour4
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 7 Nils Philippsen 2015-05-01 12:38:38 UTC
Thanks for the review!

I'll make a couple of changes to fix the remaining issues:

(In reply to Brendan Jones from comment #6)
[...]
> Issues:
> =======
> - Static libraries in -static or -devel subpackage, providing -devel if
>   present.
>   Note: Package has .a files: ardour4. Illegal package name: ardour4. Does
> not
>   provide -static: ardour4.
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries

- Don't install the offending static archive (which previously was dynamically linked to a different private library), I've submitted this upstream.

> ardour4.i686: W: cross-directory-hard-link
> /usr/share/ardour4/icons/ardour_icon_512px.png
> /usr/share/icons/hicolor/512x512/apps/ardour4.png
[...]
> ardour4.i686: W: cross-directory-hard-link
> /usr/share/ardour4/icons/ardour_icon_16px.png
> /usr/share/icons/hicolor/16x16/apps/ardour4.png
[...]
> ardour4.i686: W: cross-directory-hard-link
> /usr/share/icons/hicolor/32x32/apps/ardour4.png
> /usr/share/ardour4/icons/ardour_icon_32px.png
[...]
> ardour4.i686: W: cross-directory-hard-link
> /usr/share/icons/hicolor/22x22/apps/ardour4.png
> /usr/share/ardour4/icons/ardour_icon_22px.png
[...]
> ardour4.i686: W: cross-directory-hard-link
> /usr/share/icons/hicolor/256x256/apps/ardour4.png
> /usr/share/ardour4/icons/ardour_icon_256px.png
[...]
> ardour4.i686: W: cross-directory-hard-link
> /usr/share/ardour4/icons/ardour_icon_48px.png
> /usr/share/icons/hicolor/48x48/apps/ardour4.png
[...]

- Used symlinks rather than hardlinks.

> ardour4.src: W: strange-permission Ardour-4.0.0.tar.bz2 0640L

- Fixed.

Comment 8 Nils Philippsen 2015-05-01 12:44:40 UTC
New Package SCM Request
=======================
Package Name: ardour4
Short Description: Digital Audio Workstation
Upstream URL: http://ardour.org
Owners: nphilipp
Branches: f21 f22 
InitialCC:

Comment 9 Gwyn Ciesla 2015-05-01 13:10:48 UTC
Git done (by process-git-requests).

Comment 10 Fedora Update System 2015-05-01 15:26:03 UTC
ardour4-4.0.0-1.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/ardour4-4.0.0-1.fc22

Comment 11 Fedora Update System 2015-05-01 15:26:10 UTC
ardour4-4.0.0-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/ardour4-4.0.0-1.fc21

Comment 12 Fedora Update System 2015-05-02 18:04:34 UTC
ardour4-4.0.0-1.fc21 has been pushed to the Fedora 21 testing repository.

Comment 13 Jonathan Underwood 2015-05-02 19:55:14 UTC
On starting ardour4-4.0.0-1.fc21 I get the dialogue box with:

WARNING: Your system has a limit for maximum amount of locked memory. This might cause Ardour to run out of memory before your system runs out of memory. 

You can view the memory limit with 'ulimit -l', and it is normally controlled by  /etc/security/limits.conf

Comment 14 Nils Philippsen 2015-05-03 16:29:25 UTC
(In reply to Jonathan Underwood from comment #13)
> On starting ardour4-4.0.0-1.fc21 I get the dialogue box with:
> 
> WARNING: Your system has a limit for maximum amount of locked memory. This
> might cause Ardour to run out of memory before your system runs out of
> memory. 
> 
> You can view the memory limit with 'ulimit -l', and it is normally
> controlled by  /etc/security/limits.conf

You can increase the memlock value for your user to more than 4GB of RAM -- it's set to that value in /etc/security/limits.d/95-jack.conf. I'm not sure about the reasons for the warning because it seems to work fine without doing that.

Comment 15 Be 2015-05-08 05:25:27 UTC
If users should start new sessions with Arduour 4, then I think this package should be called 'ardour' and the current 'ardour' (2) should be renamed 'ardour2' if kept in Fedora. Users are going to expect the latest version of ardour to be installed when they install the package called 'ardour'. When I first tried Ardour around a year ago, I thought Ardour 2 was the latest version for a while until I explored the Ardour website and realized there was a separate package in Fedora called 'ardour3'.

Is it really necessary to retain Ardour 2 and 3 in Fedora anyway? Because Ardour 4 was released recently, retaining Ardour 3 would make sense because users are fairly likely to have Ardour 3 sessions that they want to work with. Are there many users who still actively work on Ardour 2 sessions? Is it worth having this awkward package naming situation to retain backwards compatibility with software that has been outdated for years? To me, that doesn't seem very well in line with Fedora's foundation value of "First".

Comment 16 Nils Philippsen 2015-05-08 15:59:52 UTC
(In reply to Be from comment #15)

The reasons for the status quo are two-fold:

- Session files of Ardour v2 are incompatible with versions >= 3. The later versions can migrate old sessions, but some information may be lost.
- To introduce version 3 in the then current stable Fedora releases it needed to get a different name, hence "ardour3".

I've made a proposal on fedora-music-list how to deal with this issue in the future, to make transitions a little smoother and new/current versions easier to discover:

https://lists.fedoraproject.org/pipermail/music/2015-May/002005.html

I'd appreciate your comments there.

Comment 17 Fedora Update System 2015-05-11 00:12:16 UTC
ardour4-4.0.0-2.fc22 has been pushed to the Fedora 22 stable repository.

Comment 18 Fedora Update System 2015-05-12 20:45:30 UTC
ardour4-4.0.0-2.fc21 has been pushed to the Fedora 21 stable repository.


Note You need to log in before you can comment on or make changes to this bug.